// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - JobQueryDBBean
*/
package WebSphereSamples.YourCo.Jobs;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class JobQueryDBBean extends java.lang.Object
{
   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for job_position property
   */
   protected java.lang.String job_position = null;

   /**
   * Instance variable for job_level property
   */
   protected java.lang.String job_level = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;

   /**
   * Vector to hold JOBS_POST_DATE property values
   */
   protected Vector JOBS_POST_DATEVector = new Vector();

   /**
   * Vector to hold JOBS_POSITION property values
   */
   protected Vector JOBS_POSITIONVector = new Vector();

   /**
   * Vector to hold JOBS_LEVEL property values
   */
   protected Vector JOBS_LEVELVector = new Vector();

   /**
   * Vector to hold DEPARTMENT_DEPTNAME property values
   */
   protected Vector DEPARTMENT_DEPTNAMEVector = new Vector();

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Get method for the job_position property
   * @return the value of the job_position property
   */
   public java.lang.String getJob_position()
   {
      return job_position;
   }

   /*****************************************************************************
   * Set method for the job_position property
   * @param value the new value for the job_position property
   */
   public void setJob_position(java.lang.String value)
   {
      this.job_position = value;
   }

   /*****************************************************************************
   * Get method for the job_level property
   * @return the value of the job_level property
   */
   public java.lang.String getJob_level()
   {
      return job_level;
   }

   /*****************************************************************************
   * Set method for the job_level property
   * @param value the new value for the job_level property
   */
   public void setJob_level(java.lang.String value)
   {
      this.job_level = value;
   }

   /*****************************************************************************
   * Get method for the indexed JOBS_POST_DATE property
   * @param index The 0 based index of the desired value
   * @return the value of the JOBS_POST_DATE property at the specified index
   */
   public java.lang.String getJOBS_POST_DATE(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)JOBS_POST_DATEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed JOBS_POSITION property
   * @param index The 0 based index of the desired value
   * @return the value of the JOBS_POSITION property at the specified index
   */
   public java.lang.String getJOBS_POSITION(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)JOBS_POSITIONVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed JOBS_LEVEL property
   * @param index The 0 based index of the desired value
   * @return the value of the JOBS_LEVEL property at the specified index
   */
   public java.lang.String getJOBS_LEVEL(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)JOBS_LEVELVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed DEPARTMENT_DEPTNAME property
   * @param index The 0 based index of the desired value
   * @return the value of the DEPARTMENT_DEPTNAME property at the specified index
   */
   public java.lang.String getDEPARTMENT_DEPTNAME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)DEPARTMENT_DEPTNAMEVector.elementAt(index);
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery( "SELECT JOBS.POST_DATE, JOBS.POSITION, JOBS.THELEVEL, " +
                                        "DEPARTMENT.DEPTNAME FROM DEPARTMENT, JOBS " +
                                        "WHERE ( ( JOBS.DEPT_NO = DEPARTMENT.DEPTNO ) AND " +
                                        "( ( JOBS.POSITION = '" + insertQuoteEscape(job_position) + "' ) " +
                                        "AND ( JOBS.THELEVEL = '" + insertQuoteEscape(job_level) + "' ) ) ) " +
                                        "ORDER BY JOBS.POST_DATE, JOBS.POSITION, JOBS.THELEVEL, DEPARTMENT.DEPTNAME" );
      // There will usually be multiple rows.
      while (rs.next())
      {
         JOBS_POST_DATEVector.addElement(rs.getString(1));
         JOBS_POSITIONVector.addElement(rs.getString(2));
         JOBS_LEVELVector.addElement(rs.getString(3));
         DEPARTMENT_DEPTNAMEVector.addElement(rs.getString(4));
      }
      JOBS_POST_DATEVector.trimToSize();
      JOBS_POSITIONVector.trimToSize();
      JOBS_LEVELVector.trimToSize();
      DEPARTMENT_DEPTNAMEVector.trimToSize();
      rs.close();
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }

   /*****************************************************************************
   * InstantDB fails with SQL text string containing single quote ' - needs escaped
   * single quote \' to work properly.
   * Let's meet
   * ...converted to...
   * Let\'s meet
   * Also, backslash \ needs to be escaped.
   * C:\wombat
   * ...converted to...
   * C:\\wombat
   * Must handle \ and ' combination.
   * O\'DONNEL
   ...converted to...
   * O\\\'DONNEL
   *
   * @param String possibly containing a single quote
   * @return String with single quote escaped
   */
   private String insertQuoteEscape(String input)
   {
      // Turns O\'DONNEL to O\\'DONNEL (escape the \)
      // Escape the \ first, or else we would mistakenly
      // escape the \ added to escape the '.
      StringBuffer buffer = new StringBuffer(input.length());
      char testChar;
      for (int i = 0; i < input.length(); i++)
      {
         testChar = input.charAt(i);
         if (testChar == '\\')
         {
            buffer.append('\\');
         }
         buffer.append(testChar);
      }
      String input1 = buffer.toString();
      // Turns O\\'DONNEL to O\\\'DONNEL (escape the ')
      StringBuffer buffer1 = new StringBuffer(input1.length());
      for (int j = 0; j < input1.length(); j++)
      {
         testChar = input1.charAt(j);
         if (testChar == '\'')
         {
            buffer1.append('\\');
         }
         buffer1.append(testChar);
      }
      return buffer1.toString();
   }
}
